<?php
/*
Plugin Name: Firedrum Email Marketing Signup Form
Plugin URI: http://www.firedrum.com/
Description: The Firedrum Internet Marketing plugin allows you to quickly and easily add a signup form for your Firedrum Internet Marketing list. Use short-code <strong>[firedrum_marketing]</strong> in template or post or pages to display this newsletter form.
Version: 1.2
Author: firedrum
Author URI: https://www.firedrummarketing.com/api/v2docs.jsp
*/

define('FD_VER', '1.2');

// Define our location constants
fierdrum_location();
// includes the widget code so it can be easily called
include_once('firedrum_widget.php');

add_action('admin_menu', 'firedrum_menu');
	
	function firedrum_menu() {
		$page_hook_suffix = add_menu_page('FireDrum', 'FireDrum', 'manage_options', 'firedrum-page', 'fp_render_list_page' );
                add_action('admin_print_scripts-' . $page_hook_suffix, 'firedrum_add_js_admin');
	} // function firedrum_menu() ends
        
        
        
        function firedrum_request_method() {
			$msg='';
			firedrum_load_resources();
            if (isset($_POST['fire_action'])) {
                switch ($_POST['fire_action']){
                    case 'add_api_key';
						if(!isset($_POST['fd_apikey']) || $_POST['fd_apikey']=='')
						{
							$msg = '<p class="unsuccess_msg">'.esc_html(__('Please Enter API Key', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
						else
						{
							update_option('fd_apikey', strip_tags(stripslashes($_POST['fd_apikey'])));
							$msg = '<p class="success_msg">'.esc_html(__('API Key Successfully Saved', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
							break;
					case 'update_api_key';
						if($_POST['new_api_key']!='')
						{
							update_option('fd_apikey', strip_tags(stripslashes($_POST['new_api_key'])));
							$msg = '<p class="success_msg">'.esc_html(__('API Key Successfully Updated', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
						elseif(isset($_POST['new_api_key']) && $_POST['new_api_key']=='')
						{
							$msg = '<p class="unsuccess_msg">'.esc_html(__('Please Enter API Key', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
						
                        			break;			
                        		case 'update_api_url';
						if($_POST['new_api_url']!='')
						{
							update_option('fd_api_url', strip_tags(stripslashes($_POST['new_api_url'])));
							$msg = '<p class="success_msg">'.esc_html(__('API Url Successfully Updated', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
						elseif(isset($_POST['new_api_url']) && $_POST['new_api_url']=='')
						{
							$msg = '<p class="unsuccess_msg">'.esc_html(__('Please Enter API Url', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
                       				 break;
					case 'save_form_settings';
						$category=firedrum_get_category_from_api();
						$custom_fields=firedrum_get_custom_fields_from_api();
						$flag=0;
						foreach($category['categories'] as $cat)
			  			{
							if($_POST['000'.$cat['id']]!='')
							{
								$flag=1;
							}
							
						}
						if($flag==0)
						{
							$msg = '<p class="unsuccess_msg">'.esc_html(__('ERROR: Please Select At Least One Category', 'firedrum')).'</p>';
							firedrum_global_msg($msg);
						}
						else
						{
							update_option('fd_efname', strip_tags(stripslashes($_POST['fd_efname'])));
							update_option('fd_elname', strip_tags(stripslashes($_POST['fd_elname'])));
							update_option('fd_email', strip_tags(stripslashes($_POST['fd_email'])));
							update_option('fd_company', strip_tags(stripslashes($_POST['fd_company'])));
							update_option('fd_address', strip_tags(stripslashes($_POST['fd_address'])));
							update_option('fd_address2', strip_tags(stripslashes($_POST['fd_address2'])));
							update_option('fd_city', strip_tags(stripslashes($_POST['fd_city'])));
							update_option('fd_state', strip_tags(stripslashes($_POST['fd_state'])));
							update_option('fd_zip', strip_tags(stripslashes($_POST['fd_zip'])));
							update_option('fd_phone', strip_tags(stripslashes($_POST['fd_phone'])));
							update_option('fd_mphone', strip_tags(stripslashes($_POST['fd_mphone'])));
							update_option('fd_fax', strip_tags(stripslashes($_POST['fd_fax'])));
							update_option('fd_gender', strip_tags(stripslashes($_POST['fd_gender'])));
							update_option('fd_bday', strip_tags(stripslashes($_POST['fd_bday'])));
							update_option('fd_annv', strip_tags(stripslashes($_POST['fd_annv'])));
							update_option('fd_cat_use', strip_tags(stripslashes($_POST['fd_cat_use'])));
							
							if(is_array($category['categories']))
							  {
								foreach($category['categories'] as $cat)
								{
									
									update_option('000'.$cat['id'], strip_tags(stripslashes($_POST['000'.$cat['id']])));
									
								}
							  }
							 if(is_array($custom_fields['customFields']))
							  {
								  foreach($custom_fields['customFields'] as $field)
								  {
									  update_option('cust#_'.$field['id'], strip_tags(stripslashes($_POST['cust#_'.$field['id']])));
									  
								  }
							  }
							update_option('fd_header_content', $_POST['fd_header_content']);
							update_option('fd_subheader_content', $_POST['fd_subheader_content']);
							update_option('fd_submit_text', strip_tags(stripslashes($_POST['fd_submit_text'])));
                                                        update_option('fd_form_poweredby', strip_tags(stripslashes($_POST['fd_form_poweredby'])));
							update_option('fd_form_styling', strip_tags(stripslashes($_POST['fd_form_styling'])));
							update_option('fd_form_border', strip_tags(stripslashes($_POST['fd_form_border'])));
							update_option('fd_form_border_color', strip_tags(stripslashes($_POST['fd_form_border_color'])));
							update_option('fd_form_background_color', strip_tags(stripslashes($_POST['fd_form_background_color'])));
							update_option('fd_form_text_color', strip_tags(stripslashes($_POST['fd_form_text_color'])));
							update_option('fd_form_text_size', strip_tags(stripslashes($_POST['fd_form_text_size'])));
							update_option('fd_form_text_font', strip_tags(stripslashes($_POST['fd_form_text_font'])));
						}
						break;
					case 'fd_submit_signup_form';
						
							// Attempt the signup
							firedrum_signup_submit();
			
							// Do a different action for html vs. js
							switch ($_POST['fd_submit_type']) {
								case 'html':
									/* Allow to fall through.  The widget will pick up the
									* global message left over from the signup_submit function */
									break;
								case 'js':
									if (!headers_sent()){ //just in case...
										header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT', true, 200);
									}
									echo firedrum_global_msg(); // Don't esc_html this, b/c we've already escaped it
									exit;
							}
							
                }
            }
        }
        add_action('init', 'firedrum_request_method');
        
function fp_render_list_page(){ ?>

<div class="wrap">
	<div id="icon-options-general" class="icon32"><br /></div>
	<h2>Firedrum Setup </h2>
    <br/>
	<div id="fd_message" class=""><?php echo firedrum_global_msg(); ?></div>
<?php 
//$api_key = get_option('fd_apikey');


?>
<?php if (get_option('fd_apikey') == '') { ?>      
	<form action="" method="post">
		<h3><?php esc_html_e('Login Info', 'firedrum');?></h3>
		<table class="form-table">
		<tr valign="top">
		<th scope="row"><?php esc_html_e('API Key', 'firedrum'); ?>:</th>
		<td>
			<input name="fd_apikey" type="text" id="fd_apikey" class="code" value="" size="32" /> <br/>
								<input type="hidden" name="fire_action" value="add_api_key" />
								<input type="submit" name="Submit" value="<?php esc_attr_e('Save & Check', 'firedrum');?>" class="button" />
		</td>
		</tr>
</table>
	</form>
	<?php 
	} else { ?>
     <br/>
      <br/>
    <form method="post" action="">
<div style="width:600px;">

<input type="hidden" name="fire_action" value="update_api_key">

<table class="widefat">

     <tr valign="top">
    <th scope="row"><?php esc_html_e('Current API Key', 'firedrum'); ?>:</th>
    <td id="fd_api_key" onclick="javascript:addInput(this);"><?php echo get_option('fd_apikey');?></td>
    <td><input type="submit" value="<?php esc_attr_e('Update API Key', 'firedrum'); ?>" class="button" />	</td>
    </tr> 
  
</table>

</div>
</form>
<br>
<form method="post" action="">
<div style="width:600px;">

<input type="hidden" name="fire_action" value="update_api_url">

<table class="widefat">
    
   <tr valign="top">
    <th scope="row"><?php esc_html_e('Current API Url', 'firedrum'); ?>:</th>
    <td id="fd_api_url" onclick="javascript:addInput2(this);"><?php echo get_option('fd_api_url','api.firedrummarketing.com/api/v2.jsp');?></td>
    <td><input type="submit" value="<?php esc_attr_e('Update API Url', 'firedrum'); ?>" class="button" />	</td>
    </tr> 
   
</table>

</div>
</form>
	
      <?php if(firedrum_check_api_key() == "8") { ?>
            
      <div class="apiNotCorrect"><?php esc_html_e('API is not correct. Please cross check the API details.', 'firedrum'); ?></div>
      
      <?php } else { ?>
	  <br/>
          <div>Short Code: <span style="font-weight: bold; font-size: 14px;"> [firedrum_marketing] </span> <br/>
  Use this short code in template or post or pages to display this newsletter form. </div>
          <br/>
	   <form method="post" action="">
<div style="width:600px;">
<input type="hidden" name="fire_action" value="save_form_settings">
<input type="submit" value="<?php esc_attr_e('Update Form Settings', 'firedrum'); ?>" class="button" /><br />
<br />
<table class="widefat">
    <tr valign="top">
    <th scope="row" colspan="2"><strong>General Information</strong></th>
    </tr>
    
    <tr valign="top">
    <th width="70%" scope="row"><?php esc_html_e('First Name', 'firedrum'); ?>:</th>
    <td width="30%"><input name="fd_efname" type="checkbox"<?php if (get_option('fd_efname')=='efname' || $_POST['fd_efname']=='efname') { echo ' checked="checked"'; } ?> id="fd_efname" class="code" value="efname" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Last Name', 'firedrum'); ?>:</th>
    <td><input name="fd_elname" type="checkbox"<?php if (get_option('fd_elname')=='elname' || $_POST['fd_elname']=='elname') { echo ' checked="checked"'; } ?> id="fd_elname" class="code" value="elname" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Email Address*', 'firedrum'); ?>:</th>
    <td><input name="fd_email" type="checkbox" <?php  echo 'checked="checked"';  ?> id="fd_email" class="code" disabled="" value="email" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Company', 'firedrum'); ?>:</th>
    <td><input name="fd_company" type="checkbox"<?php if (get_option('fd_company')=='company' || $_POST['fd_company']=='company') { echo ' checked="checked"'; } ?> id="fd_company" class="code" value="company" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Address', 'firedrum'); ?>:</th>
    <td><input name="fd_address" type="checkbox"<?php if (get_option('fd_address')=='address' || $_POST['fd_address']=='address') { echo ' checked="checked"'; } ?> id="fd_address" class="code" value="address" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Address 2', 'firedrum'); ?>:</th>
    <td><input name="fd_address2" type="checkbox"<?php if (get_option('fd_address2')=='address2' || $_POST['fd_address2']=='address2') { echo ' checked="checked"'; } ?> id="fd_address2" class="code" value="address2" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('City', 'firedrum'); ?>:</th>
    <td><input name="fd_city" type="checkbox"<?php if (get_option('fd_city')=='city' || $_POST['fd_city']=='city') { echo ' checked="checked"'; } ?> id="fd_city" class="code" value="city" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('State', 'firedrum'); ?>:</th>
    <td><input name="fd_state" type="checkbox"<?php if (get_option('fd_state')=='state' || $_POST['fd_state']=='state') { echo ' checked="checked"'; } ?> id="fd_state" class="code" value="state" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Zip', 'firedrum'); ?>:</th>
    <td><input name="fd_zip" type="checkbox"<?php if (get_option('fd_zip')=='zip' || $_POST['fd_zip']=='zip') { echo ' checked="checked"'; } ?> id="fd_zip" class="code" value="zip" style="cursor: pointer;" />
    
    </td>
    </tr>  
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Phone', 'firedrum'); ?>:</th>
    <td><input name="fd_phone" type="checkbox"<?php if (get_option('fd_phone')=='phone' || $_POST['fd_phone']=='phone') { echo ' checked="checked"'; } ?> id="fd_phone" class="code" value="phone" style="cursor: pointer;" />
    
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Mobile', 'firedrum'); ?>:</th>
    <td><input name="fd_mphone" type="checkbox"<?php if (get_option('fd_mphone')=='mphone' || $_POST['fd_mphone']=='mphone') { echo ' checked="checked"'; } ?> id="fd_mphone" class="code" value="mphone" style="cursor: pointer;" />
    
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Fax', 'firedrum'); ?>:</th>
    <td><input name="fd_fax" type="checkbox"<?php if (get_option('fd_fax')=='fax' || $_POST['fd_fax']=='fax') { echo ' checked="checked"'; } ?> id="fd_fax" class="code" value="fax" style="cursor: pointer;" />
    
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Gender', 'firedrum'); ?>:</th>
    <td><input name="fd_gender" type="checkbox"<?php if (get_option('fd_gender')=='gender' || $_POST['fd_gender']=='gender') { echo ' checked="checked"'; } ?> id="fd_gender" class="code" value="gender" style="cursor: pointer;" />
    
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Birthday', 'firedrum'); ?>:</th>
    <td><input name="fd_bday" type="checkbox"<?php if (get_option('fd_bday')=='bday' || $_POST['fd_bday']=='bday') { echo ' checked="checked"'; } ?> id="fd_bday" class="code" value="bday" style="cursor: pointer;" />
    
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Anniversary', 'firedrum'); ?>:</th>
    <td><input name="fd_annv" type="checkbox"<?php if (get_option('fd_annv')=='annv' || $_POST['fd_annv']=='annv') { echo ' checked="checked"'; } ?> id="fd_annv" class="code" value="annv" style="cursor: pointer;" />
    
    </td>
    </tr>
    </table><br />

    
    <table class="widefat">
      <tr valign="top">
            <th scope="row" colspan="2"><strong>Custom Fields</strong></th>
            </tr> 
    
            <?php $custom_fields=firedrum_get_custom_fields_from_api();
			/*echo "<pre>";
			print_r($custom_fields);
			echo "</pre>";*/
			
			?>
                      
              <?php 
			  if(is_array($custom_fields['customFields']))
			  {
				  foreach($custom_fields['customFields'] as $field)
				  {
					  ?>
				  <tr>
					<th width="70%" scope="row"><label><?php echo $field['name'];?></label></th>
				  <td width="30%"><input type="checkbox" <?php if (get_option('cust#_'.$field['id'])==$field['name'] || $_POST['cust#_'.$field['id']]==$field['name']) { echo ' checked="checked"'; } ?> value="<?php echo $field['name'] ;?>"  name="<?php echo 'cust#_'.$field['id'];?>" ></td>
                  </tr>
				  <?php
				  }
			  }
			  ?>
             
              
		</table>

    <br />

    
    
    <table class="widefat">
    
    <tr>
        <th scope="row" colspan="2">
            <strong>Categories</strong></th>
            </tr> 
    
    <tr>
    <tr valign="top">
    
    <th colspan="2" scope="row"><input name="fd_cat_use" type="radio"  checked="" id="fd_cat_use" class="code" value="Y" style="cursor: pointer;" />  <?php esc_html_e('Use Checkboxes', 'firedrum'); ?>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <input name="fd_cat_use" type="radio" <?php if (get_option('fd_cat_use')=='N' || $_POST['fd_cat_use']=='N') { echo ' checked="checked"'; } ?> id="fd_cat_use" class="code" value="N" style="cursor: pointer;" />  <?php esc_html_e('Hide Categories', 'firedrum'); ?>:</th>

    </tr>

            <?php
			$category=firedrum_get_category_from_api();
			
			?>
              <?php 
			  if(is_array($category['categories']))
			  {
				  foreach($category['categories'] as $cat)
				  {
					  ?>
			     <tr>   
            <th width="70%" scope="row"><label><?php echo $cat['name'];?></label></th>
            <td><input type="checkbox" <?php if (get_option('000'.$cat['id'])=='c000'.$cat['id'] || $_POST['000'.$cat['id']]=='c000'.$cat['id']) { echo ' checked="checked"'; } ?> value="<?php echo 'c000'.$cat['id'] ;?>"  name="000<?php echo $cat['id'];?>" ></td>
				  </tr>
				  <?php
				  }
			  }
			  ?>
             
              
			</table>
  <br />

      <table class="widefat"> 
          <tr>
        <th scope="row" colspan="2">
            <strong>Style Formatting</strong></th>
            </tr> 
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Header content', 'firedrum'); ?>:</th>
    <td>
    <textarea name="fd_header_content" rows="2" cols="50"><?php if (get_option('fd_header_content')!='') { echo esc_html(get_option('fd_header_content')); } elseif($_POST['fd_header_content']!='') { echo esc_html($_POST['fd_header_content']); }  ?></textarea>
    
    </td>
    </tr> 
    
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Sub-header content', 'firedrum'); ?>:</th>
    <td>
    <textarea name="fd_subheader_content" rows="2" cols="50"><?php if (get_option('fd_subheader_content')!='') { echo esc_html(get_option('fd_subheader_content')); } elseif($_POST['fd_subheader_content']!='') { echo esc_html($_POST['fd_subheader_content']); }  ?></textarea>
    
    </td>
    </tr> 
    
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Submit Button Text', 'firedrum'); ?>:</th>
    <td>
    
    <input type="text" name="fd_submit_text" size="30" value="<?php if (get_option('fd_submit_text')!='') { echo esc_attr(get_option('fd_submit_text')); } elseif($_POST['fd_submit_text']!='') { echo esc_attr($_POST['fd_submit_text']); }  ?>"/>
    
    </td>
    </tr> 
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Enable anti-spam honeypot', 'firedrum'); ?>:</th>
    <td><input name="fd_form_javascript" type="checkbox"<?php if (get_option('fd_form_honeypot')=='Y' || $_POST['fd_form_javascript']=='Y') { echo ' checked="checked"'; } ?> id="fd_form_honeypot" class="code" value="Y" style="cursor: pointer;" />
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Use Javascript Support?', 'firedrum'); ?>:</th>
    <td><input name="fd_form_javascript" type="checkbox"<?php if (get_option('fd_form_javascript')=='Y' || $_POST['fd_form_javascript']=='Y') { echo ' checked="checked"'; } ?> id="fd_form_javascript" class="code" value="Y" style="cursor: pointer;" />
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Turning this on will place a "powered by FireDrum" link in your form?', 'firedrum'); ?>:</th>
    <td><input name="fd_form_poweredby" type="checkbox"<?php if (get_option('fd_form_poweredby')=='Y' || $_POST['fd_form_poweredby']=='Y') { echo ' checked="checked"'; } ?> id="fd_form_poweredby" class="code" value="Y" style="cursor: pointer;" />
    </td>
    </tr>  
    
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Enable Custom Styling', 'firedrum'); ?>:</th>
    <td><input name="fd_form_styling" onclick="return disabledCustomStyle();" type="checkbox"<?php if (get_option('fd_form_styling')=='Y' || $_POST['fd_form_styling']=='Y') { echo ' checked="checked"'; } ?> id="fd_form_styling" class="code" value="Y" style="cursor: pointer;" />
    
    </td>
    </tr>
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Enable Form Border', 'firedrum'); ?>:</th>
    <td><input name="fd_form_border" onclick="return disabledBoreder();" type="checkbox"<?php if (get_option('fd_form_border')=='Y' || $_POST['fd_form_border']=='Y') { echo ' checked="checked"'; } ?> id="fd_form_border" class="code" value="Y" style="cursor: pointer;" /> &nbsp;&nbsp;&nbsp;&nbsp; <input type="text" name="fd_form_border_color" id="fd_form_border_color" class="fd_form_border_color" size="30" value="<?php if (get_option('fd_form_border_color')!='') { echo esc_attr(get_option('fd_form_border_color')); } elseif($_POST['fd_form_border_color']!='') { echo esc_attr($_POST['fd_form_border_color']); }  ?>" disabled=""/>
    
    </td>
    </tr>
     
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Form Background Color', 'firedrum'); ?>:</th>
    <td>
    
       <input type="text" id="fd_form_background_color" class="fd_form_background_color" name="fd_form_background_color" size="30" disabled="" value="<?php if (get_option('fd_form_background_color')!='') { echo esc_attr(get_option('fd_form_background_color')); } elseif($_POST['fd_form_background_color']!='') { echo esc_attr($_POST['fd_form_background_color']); }  ?>"/>
    
    </td>
    </tr> 
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Text Color', 'firedrum'); ?>:</th>
    <td>
    
    <input type="text" id="fd_form_text_color" name="fd_form_text_color" class="fd_form_text_color" disabled="" size="30" value="<?php if (get_option('fd_form_text_color')!='') { echo esc_attr(get_option('fd_form_text_color')); } elseif($_POST['fd_form_text_color']!='') { echo esc_attr($_POST['fd_form_text_color']); }  ?>"/>
    
    </td>
    </tr> 
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Text Size', 'firedrum'); ?>:</th>
    <td>
    
    <input type="text" id="fd_form_text_size" name="fd_form_text_size" disabled="" size="30" value="<?php if (get_option('fd_form_text_size')!='') { echo esc_attr(get_option('fd_form_text_size')); } elseif($_POST['fd_form_text_size']!='') { echo esc_attr($_POST['fd_form_text_size']); }  ?>"/>
    
    </td>
    </tr> 
    <tr valign="top">
    <th scope="row"><?php esc_html_e('Text Font', 'firedrum'); ?>:</th>
    <td>
   
    <select name="fd_form_text_font" id="fd_form_text_font" disabled="">
    <option value="Arial"  <?php if (get_option('fd_form_text_font')=='Arial') { echo 'selected="selected"'; } elseif($_POST['fd_form_text_font']=='Arial') { echo 'selected="selected"'; }  ?>>Arial</option>
    <option value="Courier" <?php if (get_option('fd_form_text_font')=='Courier') { echo 'selected="selected"'; } elseif($_POST['fd_form_text_font']=='Courier') { echo 'selected="selected"'; }  ?>>Courier</option>
    <option value="Georgia" <?php if (get_option('fd_form_text_font')=='Georgia') { echo 'selected="selected"'; } elseif($_POST['fd_form_text_font']=='Georgia') { echo 'selected="selected"'; }  ?>>Georgia</option>
    <option value="Helvetica" <?php if (get_option('fd_form_text_font')=='Helvetica') { echo 'selected="selected"'; } elseif($_POST['fd_form_text_font']=='Helvetica') { echo 'selected="selected"'; }  ?>>Helvetica</option>
    <option value="Verdana" <?php if (get_option('fd_form_text_font')=='Verdana') { echo 'selected="selected"'; } elseif($_POST['fd_form_text_font']=='Verdana') { echo 'selected="selected"'; }  ?>>Verdana</option>
    </select>
    
    </td>
    </tr> 
     
</table>
</div><br />

<input type="submit" value="<?php esc_attr_e('Update Form Settings', 'firedrum'); ?>" class="button" />
</form>
	
	<?php 
      }	} ?>
</div>

            
      <?php } // function fp_render_list_page() ends
      
      
function firedrum_stylesheet_admin() {
	
	wp_register_style('firedrum_stylesheet', plugins_url('css/firedrum.css', __FILE__) );
        wp_enqueue_style( 'wp-color-picker');
	wp_enqueue_style('firedrum_stylesheet');
	
} // function firedrum_stylesheet_admin() ends

add_action('admin_head', 'firedrum_stylesheet_admin');


 function firedrum_stylesheet_front() {
	
	wp_register_style('firedrum_stylesheet_front', plugins_url('css/firedrum_front.css', __FILE__) );
	wp_enqueue_style('firedrum_stylesheet_front');
	
} // function firedrum_stylesheet_front() ends

add_action('wp_enqueue_scripts', 'firedrum_stylesheet_front');

function firedrum_global_msg($msg = null) {
	global $fd_msgs;

	// Make sure we're formed properly
	if (!is_array($fd_msgs)) {
		$fd_msgs = array();
	}

	// See if we're getting
	if (is_null($msg)) {
		return implode('', $fd_msgs);
	}

	// Must be setting
	$fd_msgs[] = $msg;
	return true;
} // function firedrum_global_msg() ends


function firedrum_register_widgets() {
	register_widget('Firedrum_Widget');
}
add_action('widgets_init', 'firedrum_register_widgets');

function firedrum_shortcode($atts){
	ob_start();
	firedrum_signup_form();
	return ob_get_clean();
}
add_shortcode('firedrum_form', 'firedrum_shortcode');

function firedrum_get_category_from_api()
{
	$context = stream_context_create(array('http' => array('header'=>'Connection: close\r\n')));
	$jsonCat=file_get_contents('http://'.get_option('fd_api_url','api.firedrummarketing.com/api/v2.jsp').'?action=Category_List&authAPIKey='.get_option('fd_apikey'),false,$context);
	$dataCat = json_decode($jsonCat, TRUE);
	return $dataCat;
} // function firedrum_get_category_from_api() ends


function firedrum_get_custom_fields_from_api()
{
	$context = stream_context_create(array('http' => array('header'=>'Connection: close\r\n')));
	$jsonCat=file_get_contents('http://'.get_option('fd_api_url','api.firedrummarketing.com/api/v2.jsp').'?action=CustomField_List&authAPIKey='.get_option('fd_apikey'),false,$context);
	$dataCat = json_decode($jsonCat, TRUE);
	return $dataCat;
} // function firedrum_get_custom_fields_from_api() ends

function firedrum_check_api_key(){
    $context = stream_context_create(array('http' => array('header'=>'Connection: close\r\n')));
    $jsonCheckAPI = file_get_contents('http://'.get_option('fd_api_url','api.firedrummarketing.com/api/v2.jsp').'?action=Category_List&authAPIKey='.get_option('fd_apikey'),false,$context);
    $dataAPI = json_decode($jsonCheckAPI);
    return $dataAPI->responseCode->id;
    
}

function firedrum_load_resources() {
	// JS
	if (get_option('fd_form_javascript') == 'Y') {
		if (!is_admin()) {
			wp_enqueue_script('jquery_scrollto', FD_URL.'js/scrollTo.js', array('jquery'), FD_VER);
			wp_enqueue_script('firedrum_main_js', FD_URL.'js/firedrum.js', array('jquery', 'jquery-form'), FD_VER);
			
			// some javascript to get ajax version submitting to the proper location
			global $wp_scripts;
			$wp_scripts->localize('firedrum_main_js', 'firedrum', array(
				'ajax_url' => trailingslashit(home_url()),
			));
		}
	}
	
	wp_enqueue_style('firedrum_main_css', home_url('?fd_action=main_css&ver='.FD_VER,$scheme = relative ));
	
	global $wp_styles;
	$wp_styles->add_data( 'firedrum_ie_css', 'conditional', 'IE' );
} // function firedrum_load_resources() ends

function firedrum_add_js_admin(){

    wp_enqueue_script( 'my-script-handle', plugins_url('js/my-colorpicker.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
    wp_enqueue_script('firedrum_addinput', FD_URL.'js/firedrum_addinput.js', array('jquery'), FD_VER);
}

function firedrum_early_request_handler() {
	if (isset($_GET['fd_action'])) {
		switch ($_GET['fd_action']) {
			case 'main_css':
				header("Content-type: text/css");
				firedrum_main_css();
				exit;
		}
	}
} // function firedrum_early_request_handler() ends

add_action('init', 'firedrum_early_request_handler', 0);

function firedrum_main_css() {
	?>
    .fd_error_msg {
		color: red;
	}
    
    .fd_success_msg {
		color: green;
	}
	.success_msg {
    color: green;
    font-weight: bold;
    margin: 0;
    }
    
    .unsuccess_msg {
        color: red;
        font-weight: bold;
        margin: 0;
    }
    .apiNotCorrect {
        color: red;
        font-weight: bold;
        margin: 10px 0 0 0 ;
    }
	.fd_merge_var{
		padding:0;
		margin:0;
	}

	<?php
// If we're utilizing custom styles
if (get_option('fd_form_styling')=='Y'){
	?>
	#fd_signup_form {
		padding:5px;
        <?php
		if (get_option('fd_form_border')=='Y'){
		?>
		border-width: <?php echo '2'; //echo get_option('fd_form_border_width'); ?>px;
		border-style: <?php echo 'solid'; //echo (get_option('fd_form_border_width')==0) ? 'none' : 'solid'; ?>;
		border-color: <?php echo get_option('fd_form_border_color'); ?>;
        <?php
		}
		?>
		color: <?php echo get_option('fd_form_text_color'); ?>;
		background-color: <?php echo get_option('fd_form_background_color'); ?>;
        font-size: <?php echo (get_option('fd_form_text_size')=='') ? '12px' : get_option('fd_form_text_size').'px' ; ?>;
        font-family:<?php echo get_option('fd_form_text_font'); ?>;
	}


	
	<?php
}
?>
	#fd_signup_container {}
	#fd_signup_form {}
	#fd_signup_form .fd_var_label {}
	#fd_signup_form .fd_input {}
	#fd-indicates-required {
		width:100%;
	}
	#fd_display_rewards {}
	.fd_interests_header {
		font-weight:bold;
	}
	div.fd_interest{
		width:100%;
	}
	#fd_signup_form input.fd_interest {}
	#fd_signup_form select {}
	#fd_signup_form label.fd_interest_label {
		display:inline;
	}
	.fd_signup_submit {
		text-align:center;
	}
	ul.fd_list {
		list-style-type: none;
	}
	ul.fd_list li {
		font-size: 12px;
	}
	
	<?php
} // function firedrum_main_css() ends
		
function fierdrum_location() {
	$locations = array(
		'plugins' => array(
			'dir' => WP_PLUGIN_DIR,
			'url' => plugins_url()
		),
		'mu_plugins' => array(
			'dir' => WPMU_PLUGIN_DIR,
			'url' => plugins_url(),
		),
		'template' => array(
			'dir' => trailingslashit(get_template_directory()).'plugins/',
			'url' => trailingslashit(get_template_directory_uri()).'plugins/',
		),
		'stylesheet' => array(
			'dir' => trailingslashit(get_stylesheet_directory()).'plugins/',
			'url' => trailingslashit(get_stylesheet_directory_uri()).'plugins/',
		),
	);

	// Set defaults
	$fd_dirbase = trailingslashit(basename(dirname(__FILE__))); // Typically wp-mailchimp/ or mailchimp/
	$fd_dir = trailingslashit(WP_PLUGIN_DIR).$fd_dirbase;
	$fd_url = trailingslashit(WP_PLUGIN_URL).$fd_dirbase;

	// Try our hands at finding the real location
	foreach ($locations as $key => $loc) {
		$dir = trailingslashit($loc['dir']).$fd_dirbase;
		$url = trailingslashit($loc['url']).$fd_dirbase;
		if (is_file($dir.basename(__FILE__))) {
			$fd_dir = $dir;
			$fd_url = $url;
			break;
		}
	}

	// Define our complete filesystem path
	define('FD_DIR', $fd_dir);

	/* Lang location needs to be relative *from* ABSPATH,
	so strip it out of our language dir location */
	define('FD_LANG_DIR', trailingslashit(FD_DIR).'po/');

	// Define our complete URL to the plugin folder
	define('FD_URL', $fd_url);
} // function fierdrum_location() ends


/**
 * Attempts to signup a user, per the $_POST args.
 *
 * This sets a global message, that is then used in the widget
 * output to retrieve and display that message.
 *
 * @return bool
 */
function firedrum_signup_submit() {
	$success = true;
	$email = $_POST['email'];
	$errs = $html_errs = array(); // Set up some vars
	$flag=0;
	if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
		// invalid e-mail address
		$success = false;
		$errs[] = sprintf(__("You Must fill Valid  %s.", 'firedrum'), esc_html('Email Address'));
		}
	if(get_option('fd_cat_use')!='' && get_option('fd_cat_use')=='Y')
	{
		$category=firedrum_get_category_from_api();
		foreach($category['categories'] as $cat)
		  {
			  if(get_option('000'.$cat['id'])!='' && isset($_POST[get_option('000'.$cat['id'])]))
			  {
				  $flag=1;
			  }
		  }
		  if($flag==0)
		  {
		  	$success = false;
			$errs[] = sprintf(__("You Must Select At Least One  %s.", 'firedrum'), esc_html('Interest'));
		  }
	}
	// If we have errors, then show them
	if (count($errs) > 0) {
		$msg = '<span class="fd_error_msg">';
		foreach($errs as $error_index => $error){
			if (!in_array($error_index, $html_errs)) {
				$error = esc_html($error);
			}
			$msg .= '&raquo; '.$error.'<br />';
		}
		$msg .= '</span>';
	}
	else {
		$url='http://'.get_option('fd_api_url','api.firedrummarketing.com/api/v2.jsp');
		$post_url='action=Member_Add&authAPIKey='.get_option('fd_apikey').'&updateIfExists=true&email='.$email;
		if(isset($_POST['efname']))
		{
			$post_url .='&firstName='.$_POST['efname'];
		}
		if(isset($_POST['elname']))
		{
			$post_url .='&lastName='.$_POST['elname'];
		}
		if(isset($_POST['company']))
		{
			$post_url .='&company='.$_POST['company'];
		}
		if(isset($_POST['address']))
		{
			$post_url .='&address='.$_POST['address'];
		}
		if(isset($_POST['address2']))
		{
			$post_url .='&address2='.$_POST['address2'];
		}
		if(isset($_POST['city']))
		{
			$post_url .='&city='.$_POST['city'];
		}
		if(isset($_POST['state']))
		{
			$post_url .='&state='.$_POST['state'];
		}
		if(isset($_POST['zip']))
		{
			$post_url .='&zip='.$_POST['zip'];
		}
		if(isset($_POST['phone']))
		{
			$post_url .='&phone='.$_POST['phone'];
		}
		if(isset($_POST['mphone']))
		{
			$post_url .='&mobilePhone='.$_POST['mphone'];
		}
		if(isset($_POST['fax']))
		{
			$post_url .='&fax='.$_POST['fax'];
		}
		if(isset($_POST['gender']))
		{
			$post_url .='&gender='.$_POST['gender'];
		}
		if($_POST['bdaymonth'] != "" || $_POST['bdayday'] != "")
		{
			$post_url .='&birthDate='.$_POST['bdaymonth'].'-'.$_POST['bdayday'];
		}
		if($_POST['annvmonth'] != "" || $_POST['annvday'] != "" )
		{
			$post_url .='&anniversaryDate='.$_POST['annvmonth'].'-'.$_POST['annvday'];
		}
			$category=firedrum_get_category_from_api();
			if(is_array($category['categories']))
			{
				foreach($category['categories'] as $cat)
				  {
					  if(get_option('000'.$cat['id'])!='' && isset($_POST[get_option('000'.$cat['id'])]))
					  {
						  $post_url .='&categoryId[]='.str_replace("c","",$_POST[get_option('000'.$cat['id'])]);
					  }
				  }
			}
			  
			  
					  foreach ($_POST as $key => $value)
    					  	$post_data .= $key.'='.$value.'<br />';
    					  	
			$custom_fields=firedrum_get_custom_fields_from_api(); 
			if(is_array($custom_fields['customFields']))
			  {
				  foreach($custom_fields['customFields'] as $field)
				  {
				 	   if(get_option('cust#_'.$field['id'])!='' && isset($_POST['cust#_'.$field['id']]))
						{
							$post_url .='&customField[]=%7B%22name%22%3A%22'.str_replace(" ","+",$field['name']).'%22%2C%22value%22%3A%22'.$_POST['cust#_'.$field['id']].'%22%7D';
						}
					  
					  //For Date Type Custom Fields
					   if(get_option('cust#_'.$field['id'])!='' && isset($_POST['custmonth#_'.str_replace(" ","_",$field['name'])]) && isset($_POST['custday#_'.str_replace(" ","_",$field['name'])]) ) 
					   {
						$post_url .='&customField[]=%7B%22name%22%3A%22'.str_replace(" ","+",$field['name']).'%22%2C%22value%22%3A%220000-'.$_POST['custmonth#_'.str_replace(" ","_",$field['name'])].'-'.$_POST['custmonth#_'.str_replace(" ","_",$field['name'])] .'%22%7D';
					   }		
				  }
				  
			  }
		
		$ch = curl_init(); 
		curl_setopt( $ch, CURLOPT_POST, 1 ); 

		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,0); 

		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); 

		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 ); 

		curl_setopt( $ch, CURLOPT_URL, $url ); 
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $post_url );
		$txResult = curl_exec( $ch );
		$data= json_decode($txResult, TRUE);
		curl_close($ch);
		
		
		if(isset($data['responseCode']['name']) && $data['responseCode']['name']=='SUCCESS')
		{
                        $headers = 'From: '.$_POST['efname'].' <'.$_POST['email'].'>' . "\r\n";
                        $msgBody = "Hi <br/><br/> There is a new user signup on newsletter form. Please find details - <br/> Name: ".$_POST['efname']."<br/> Email: ".$_POST['email']." <br/>.... <br/><br/>Regards<br/> Firedrum Plugin";
                        wp_mail(get_option('admin_email'), ' New User Signup on Newsletter', $msgBody, $headers);
			$msg = "<strong class='fd_success_msg'>".esc_html(__("Success, you've been signed up!", 'firedrum'))."</strong>";
		}
		else if($data['validationErrors'][0]['properties']['birthDate'][0] == 'pattern' || $data['validationErrors'][0]['properties']['anniversaryDate'][0] == 'pattern') 
		{       
                 
                	$msg = "<strong class='fd_error_msg'>".esc_html(__("Either your Birthdate or Anniversary is Incorrect", 'firedrum'))."</strong>";
		}
		else 
		{
                	$msg = "<strong class='fd_error_msg'>".esc_html(__("Sorry you are not added in list because of some error", 'firedrum'))."</strong>";
		}
		
		
	}
	// Set our global message
	firedrum_global_msg($msg);

	return $success;
	
} // function firedrum_signup_submit() ends

function firedrum_set_content_type(){
    return "text/html";
}
add_filter( 'wp_mail_content_type','firedrum_set_content_type' );

function firedrum_uninstall()
{
	$category=firedrum_get_category_from_api();
	$custom_fields=firedrum_get_custom_fields_from_api();
	
	unregister_widget('Firedrum_Widget');
	delete_option( 'fd_apikey' );
	delete_option( 'fd_api_url' );
  delete_option( 'fd_efname' );
  delete_option( 'fd_elname' );
  delete_option( 'fd_email' );
  delete_option( 'fd_company' );
  delete_option( 'fd_address' );
  delete_option( 'fd_address2' );
  delete_option( 'fd_city' );
  delete_option( 'fd_state' );
  delete_option( 'fd_zip' );
  delete_option( 'fd_phone' );
  delete_option( 'fd_mphone' );
  delete_option( 'fd_fax' );
  delete_option( 'fd_gender' );
  delete_option( 'fd_bday' );
  delete_option( 'fd_annv' );
  delete_option( 'fd_cat_use' );
  
  if(is_array($category['categories']))
  {
	foreach($category['categories'] as $cat)
	{
		
		
		delete_option( '000'.$cat['id'] );
		
	}
  }
  
   if(is_array($custom_fields['customFields']))
  {
	  foreach($custom_fields['customFields'] as $field)
	  {
		  delete_option( 'cust#_'.$field['id'] );
	  }
  }
  
  
  
  delete_option( 'fd_header_content' );
  delete_option( 'fd_subheader_content' );
  delete_option( 'fd_submit_text' );
  delete_option( 'fd_form_honeypot' );
  delete_option( 'fd_form_javascript' );
  delete_option('fd_form_poweredby');
  delete_option( 'fd_form_styling' );
  delete_option( 'fd_form_border' );
  delete_option( 'fd_form_border_color' );
  delete_option( 'fd_form_background_color' );
  delete_option( 'fd_form_text_color' );
  delete_option( 'fd_form_text_size' );
  delete_option( 'fd_form_text_font' );
  
 
}// function firedrum_uninstall() ends

register_uninstall_hook(    __FILE__, 'firedrum_uninstall' );